<?
final class Sversion {
    
	/** @ var string Название продукта.  */
    public $product = 'SHCMS Engine!';

	/** @ var string Версия продукта.  */
	public $release = '5.5';
	
	/** @ var string Версия техническое обслуживание.  */
	public $dev_level = '1';
	
	/** @ var string Статус развития.  */
	public $dev_status = 'Бета-Тест';
	
	/** @ var string Номер сборки.  */
	public $build = '0';
	
	/** @var  string  Кодовое слово. */
	public $codename = 'Shamsik_SHCMS';

	/** @var  string  Дата выхода. */
    public $reldate = 'Null';
    
	/** @var  string  Время выхода. */
	public $reltime = 'Null';

    /** @var string Псевдоним разработчика CMS системы */
    public $developer = 'Shamsik';
	
    /** @var string Имя и Фамилия  */
    public $name_surname = 'Шамсик Сердеров';
	
	/** @var  string  Уведомление об авторских правах. */
	public $copyright = 'Copyright (C) 2014 - SHCMS Engine, Inc. Все права защищены.';

	/** @var  string  Текст ссылки. */
    public $url = '<a href="http://www.shcms.ru">SHCMS Engine!</a>';

    /** 
      * Сравнивает два "PHP стандартизированы" номер версии против текущей версии SHCMS Engine. 
      * 
      * @ Параметров строки $minimum Минимальная версия SHCMS Engine, который совместим. 
      * 
      * return BOOL Правда, если версия совместима. 
      * 
      */
	public function isCompatible($minimum)
	{
		return version_compare(PHP_VERSION, $minimum, 'ge');
	}

	/** 
	  * Метод, чтобы получить версию файл справки. 
      * 
      * return Строка Версия суффикс файлы справки. 
      *   
	  */	
	public function HelpVersion()
	{
		return '.' . str_replace('.', '', $this->release);
	}
	
    /** 
      * Получает "PHP стандартизированы" строку версии для текущего SHCMS Engine. 
      * 
      * return Строка Версия строка. 
      */
	public function ShortVersion()
	{
		return $this->release . '.' . $this->dev_level;
	}	
    /** 
      * Получает строку авторских прав текущего SHCMS Engine. 
      * 
      * return Строка Версия строка. 
      */
	public function CopyrightVersion() {
	    return $this->copyright;
	}
	
    /** 
      * Получает строку Разрабочика текущей системы SHCMS Engine. 
      * 
      * return Строка Полное строка версии. 
      */	
	public function AuthorVersion() {
	    return $this->name_surname.' [<font color="green">'.$this->developer.'</font>]';
	}
	
    /** 
      * Получает "PHP стандартизированы" строку номера сборки для текущего SHCMS Engine.
      * 
      * return Строка Версия строка. 
      */
	public function BuildVersion() 
	{
	    return $this->build;    
	}
	
    /** 
      * Получает строку статуса развития для текущего SHCMS Engine.
      * 
      * return Строка Версия строка. 
      */
	public function StatusVersion() 
	{
	    return $this->dev_status;    
	}	
	
	/** 
	  * Получает строку версии для текущего SHCMS Engine со всей информацией релиза. 
      * 
      * return Строка Полное строка версии. 
      */
	public function LongVersion()
	{
		return $this->product . ' ' . $this->release . '.' . $this->dev_level . ' '
			. $this->dev_status . ' [ ' . $this->codename . ' ] ' . $this->reldate . ' '
			. $this->reltime;
	}	

	/** 
      * Возвращает агента пользователя. 
      * 
      * @ Параметров строки "$component" Имя компонента. 
      * @ Параметров BOOL "$mask" Маска как Mozilla / 5,0 или нет. 
      * @ Параметров BOOL "$add_version" Добавить версию впоследствии компонента. 
      * 
      * return Строка Агент пользователя. 
      */
	public function getUserAgent($component = null, $mask = false, $add_version = true)
	{
		if ($component === null)
		{
			$component = 'Framework';
		}

		if ($add_version)
		{
			$component .= '/' . $this->release;
		}

		//Если маскируется вид, чтобы выглядеть как Mozilla 5.0, но все еще идентифицируем себя.
		if ($mask)
		{
			return 'Mozilla/5.0 ' . $this->product . '/' . $this->release . '.' . $this->dev_level . ($component ? ' ' . $component : '');
		}
		else
		{
			return $this->product . '/' . $this->release . '.' . $this->dev_level . ($component ? ' ' . $component : '');
		}
	}	
	
}

$sversion = new Sversion;
?>